﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace _1171663_GridVirtualMode
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        DataTable dt = new DataTable();

        public RadForm1()
        {
            InitializeComponent();
            dt.Columns.Add("Id", typeof(int));
            dt.Columns.Add("Name", typeof(string));

            for (int i = 0; i < 10000; i++)
            {
                dt.Rows.Add(i, "Item" + i);
            }
            this.radGridView1.EnableSorting = false;
            this.radGridView1.EnableFiltering = false;
            this.radGridView1.EnableGrouping = false;
            this.radGridView1.CellValueNeeded += radGridView1_CellValueNeeded;
            this.radGridView1.CellValuePushed += radGridView1_CellValuePushed;
            radGridView1.VirtualMode = true;
            radGridView1.ColumnCount = dt.Columns.Count;
            this.radGridView1.RowCount = dt.Rows.Count;
        }

        private void radGridView1_CellValuePushed(object sender, Telerik.WinControls.UI.GridViewCellValueEventArgs e)
        {
            dt.Rows[e.RowIndex][e.ColumnIndex] = e.Value;
        }

        private void radGridView1_CellValueNeeded(object sender, Telerik.WinControls.UI.GridViewCellValueEventArgs e)
        {
            e.Value = dt.Rows[e.RowIndex][e.ColumnIndex];
        }
    }
}